{$I DEBUG}
unit Light;

interface

uses
  CRT, Objects, VGAGraph;

const
  MaxProb	= 10;
  MaxPoints	= 20;

type
  PLightning = ^TLightning;
  TLightning = object(TObject)
    Points:	array[ 1..MaxPoints ] of record
					   Offset: Word;
					   Dir: Integer;
					 end;
    P:		PBuffer;
    UN,
    PN:		Integer;
    constructor Init( AP: PBuffer );
    procedure Draw;
    procedure Update;
{    destructor Done; virtual;}
  end;

implementation

constructor TLightning.Init( AP: PBuffer );
begin
  PN := 1;
  UN := 1;
  P := AP;
  Points[1].Offset := 120+Random(80);
  Points[1].Dir := MaxProb div 2 - 2;
end;

procedure TLightning.Draw;
var
  I:	Integer;
begin
  for I := 1 to PN do
  begin
    if Points[I].Dir > 0 then
    begin
      P^[ Points[I].Offset-1 ] := 255;
      P^[ Points[I].Offset ] := 255;
{      P^[ Points[I].Offset+1 ] := 253;}
    end;
  end;
end;

procedure TLightning.Update;
var
  I:	Integer;
begin
  for I := 1 to PN do
  begin
    if Points[I].Dir > 0 then
    begin
      if (Random(40) = 0) and (PN<MaxPoints) then
      begin
	Inc(PN); Inc(UN);
	Points[PN] := Points[I];
	Points[PN].Dir := Random(MaxProb-2)+1;{MaxProb - Points[I].Dir;}
      end;
    end;
    if Random(MaxProb) > Points[I].Dir then
      Inc(Points[I].Offset )
    else
      Dec(Points[I].Offset);
    {if Random(10) > 2 then} Inc( Points[I].Offset, 320 );
    if (Random(200) < 100) and (UN>2) then
    begin
      Points[I].Dir := 0;
      Dec(UN);
    end;
  end;
end;

end.