{$I DEBUG}
unit XGlitch;

interface

procedure DoXGlitch;

implementation

uses RStream, VGAGraph, Frames;

procedure DoXGlitch;
var
  S:		TRStream;
  HSize,
  VSize:	Word;
  Buf:		PBuffer;
  Pal,
  Pal1:         TRGBPalette;
  I, J:         Integer;
  CurOffset,
  OffsetStep:	Word;

begin
  S.Init( 'GLITC360.X' );
  S.Read( HSize, 2 );
  S.Read( VSize, 2 );
  Buf := DosAllocMem( (HSize div 4)*VSize );
  SetModeX360x480;
  FillChar( Pal, SizeOf(Pal), 63 );
{  FadeToPalette( @Pal, 3 );}
  SetPalette(@Pal);
  S.Read( Pal, 768 );
  for I := 0 to 3 do
  begin
    S.Read( Buf^, (HSize div 4)*VSize );
    PortW[$3C4] := (1 shl I) shl 8 + 2;
    for J := 0 to VSize-1 do
      Move( Buf^[J*(HSize div 4)], Mem[ SegA000: J*(HRes div 4) ], HSize div 4 );
  end;
  DosFreeMem( Buf );
  FadeToPalette( @Pal, 30 );
  for I := 1 to 80 do WaitNextFrame;
  CurOffset := 0;
  OffsetStep := 90;
  PortW[$3C4] := $F02;
  for I := 0 to 31 do
  begin
    asm
      mov bx,CurOffset
      mov dx,3d4h
      mov al,0ch
      mov ah,bh
      out dx,ax
      mov dx,3d4h
      mov al,0dh
      mov ah,bl
      out dx,ax
      les di,Screen
      mov di,CurOffset
      sub di,OffsetStep
      mov cx,OffsetStep
      xor ax,ax
      rep stosb
    end;
    Dec( CurOffset, OffsetStep );
    Inc( OffsetStep, 90 );
    WaitRetrace;
  end;
end;

end.